/* Written by Yong Li, Depeng Liu                                       */
/* Copyright (c) 2016                  	                               */
/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* This program is distributed in the hope that it will be useful,      */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License    */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

package cn.ac.ios.learner.fdfa.table;

import cn.ac.ios.automata.words.WordManager;
import cn.ac.ios.automata.words.Word;
import cn.ac.ios.learner.fdfa.LearnerFDFA;
import cn.ac.ios.learner.fdfa.LearnerLeading;
import cn.ac.ios.learner.fdfa.LearnerProgress;
import cn.ac.ios.query.MembershipOracle;

public class LearnerFDFATablePeriodic extends LearnerFDFA {

	public LearnerFDFATablePeriodic(WordManager contextWord, MembershipOracle<Boolean> membershipOracle) {
		super(contextWord, membershipOracle);
	}

	@Override
	protected LearnerLeading getLearnerLeading() {
		return new LearnerLeadingTable(contextWord, membershipOracle);
	}

	@Override
	protected LearnerProgress getLearnerProgress(Word label) {
		return new LearnerProgressTablePeriodic(contextWord, membershipOracle, label);
	}

	@Override
	protected boolean isPeriodic() {
		return true;
	}

}
