/* Written by Yong Li, Depeng Liu                                       */
/* Copyright (c) 2016                  	                               */
/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* This program is distributed in the hope that it will be useful,      */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License    */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

package cn.ac.ios.learner.kvtree;

import cn.ac.ios.automata.words.Word;
import cn.ac.ios.table.ExprValue;
import cn.ac.ios.table.HashableValue;
import cn.ac.ios.tree.Node;
import cn.ac.ios.tree.NodeAbstract;

class NodeBinary<V> extends NodeAbstract<V> {

	private boolean isAccepting = false;
	public NodeBinary(Node<V> parent, HashableValue branch, ExprValue exprValue) {
		super(parent, branch, exprValue);
	}

	@Override
	public void setAcceting() {
		isAccepting = true;
	}

	@Override
	public boolean isAccepting() {
		return isAccepting;
	} 
	
	public Node<V> getLeftNode() {
		return null;
	}
	
	public Node<V> getRightNode() {
		return null;
	}
	
	public String toString() {
		Word label = getLabel().get();  
		return label.toStringWithAlphabet() + ":" + isLeaf() + ":" + getDepth();
	}

}
