package cn.ac.ios.log;

import java.io.OutputStream;
import java.io.PrintStream;
import java.text.SimpleDateFormat;
import java.util.Date;

import algorithms.Options;

public class Log {
	
	private final PrintStream log;
	private final String DEBUG = "debug";
	private final String INFO = "info";
	private final String ERROR = "error";
	
	public Log(PrintStream out) {
		log = out;
	}
	
	public void debug(String content) {
		this.write(DEBUG, content);
	}
	
	public void verbose(String content) {
		if(Options.verbose) {
			log.println(content);
		}
	}
	
	public void println(String content) {
		log.println(content);
	}
	
	public void print(String content) {
		log.print(content);
	}
	
	public void info(String content) {
		this.write(INFO, content);
	}
	
	public void err(String content) {
		this.write(ERROR, content);
	}
	
	public OutputStream getOutputStream() {
		return log;
	}
	
	private void write(String mode, String content) {
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
		PrintStream out = log;
		if (mode == ERROR) out = System.err;
		out.printf("%s [%5s] %s\n", dateFormat.format(new Date()), mode, content);
	}

}
