/* Written by Yong Li, Depeng Liu                                       */
/* Copyright (c) 2016                  	                               */
/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* This program is distributed in the hope that it will be useful,      */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License    */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

package cn.ac.ios.oracle;

import algorithms.Minimization;
import automata.FiniteAutomaton;
import cn.ac.ios.util.UtilAutomaton;
import dk.brics.automaton.Automaton;

/* this is a minimizer (using Reduce) for Buechi automaton and 
 * NFA 
 * */

public class Minimizer {
	
	public static FiniteAutomaton minimizeBuechi(FiniteAutomaton aut, int numOfLookAhead) {
		Minimization x = new Minimization();
		FiniteAutomaton result = x.Minimize_Buchi(aut, numOfLookAhead);
		return result;
	}
	
	public static FiniteAutomaton minimizeNFA(FiniteAutomaton aut, int numOfLookAhead) {
		Minimization x = new Minimization();
		FiniteAutomaton result = x.Minimize_Finite(aut, numOfLookAhead, true, true, false);
		return result;
	}
	
	public static Automaton mimimizeNFA(Automaton aut) {
		FiniteAutomaton fa = UtilAutomaton.convertToRabitAutomaton(aut);
		fa = minimizeNFA(fa, 12); 
		aut = UtilAutomaton.convertToDkAutomaton(fa);
		return aut;
	}

}
