/* Written by Yong Li, Depeng Liu                                       */
/* Copyright (c) 2016                  	                               */
/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* This program is distributed in the hope that it will be useful,      */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License    */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

package cn.ac.ios.roll.translator;

import cn.ac.ios.automata.Acceptor;
import cn.ac.ios.automata.Automaton;
import cn.ac.ios.automata.words.WordManager;
import cn.ac.ios.learner.Learner;
import cn.ac.ios.query.Query;
import cn.ac.ios.query.QuerySimple;
import oracle.EqResult;

public class TranslatorSimple implements Translator {

	protected boolean called;
	protected Query<EqResult> ceQuery = null;
	
	public TranslatorSimple(Learner<? extends Acceptor, Boolean> learner) {
		called = false;
	}
	
	@Override
	public boolean canRefine() {
		assert ceQuery != null;
		if(! called) {
			called = true;
			return true;
		}
		return false;
	}

	@Override
	public Query<Boolean> translate() {
		return new QuerySimple<>(ceQuery.getPrefix(), ceQuery.getSuffix());
	}

	@Override
	public WordManager getContextWord() {
		return null;
	}

	@Override
	public void setQuery(Query<EqResult> query) {	
		this.ceQuery = query;
	}
}
