package cn.ac.ios.util;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;

public class NullSystemOutput {
	
	private static PrintStream orignalPrinter = null;
	
	public static void setNullOutput() {
		orignalPrinter = System.out; // keep original output
		PrintStream out;
		try {
			// the use of NullOutputStream will cause some unexpected behaviors
			out = new PrintStreamNull(new FileOutputStream("/dev/null"));
			System.setOut(out);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public static void restoreOutput() {
		if(orignalPrinter == null) {
			System.err.println("Please use setNullOutput() first");
			System.exit(-1);
		}
		System.setOut(orignalPrinter);
	}

}
