/* Written by Yong Li, Depeng Liu                                       */
/* Copyright (c) 2016                  	                               */
/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* This program is distributed in the hope that it will be useful,      */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License    */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

package cn.ac.ios.tree.fdfa;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

import cn.ac.ios.automata.words.WordManager;
import cn.ac.ios.automata.words.Word;
import cn.ac.ios.query.Query;
import cn.ac.ios.query.QuerySimple;

public class InputHelper {
	public static boolean getInputAnswer() {
		boolean answer = false;
		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
		try {
			boolean finished = false;
			while(! finished) {
				String input = reader.readLine();
				if(input.equals("1")) {
					answer = true;
					finished = true;
				}else if(input.equals("0")) {
					answer = false;
					finished = true;
				}else {
					System.out.println("Illegal input, try again!");
				}
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return answer;
	}
	
	public static Query<Boolean> getCeWord(WordManager contextWord) {
		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
		Word prefix = null, suffix = null;
		try {
			do {
				System.out.println("please input prefix: ");
				String input = reader.readLine();
				input = input.trim();
				prefix = contextWord.getWordFromString(input, "");
				if(prefix == null)	{
					System.out.println("Illegal input, try again!");
				}
			}while(prefix == null);
			
			do {
				System.out.println("please input suffix: ");
				String input = reader.readLine();
				input = input.trim();
				suffix = contextWord.getWordFromString(input, "");
				if(suffix == null)	{
					System.out.println("Illegal input, try again!");
				}
			}while(suffix == null);
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return new QuerySimple<Boolean>(prefix, suffix);
	}

}
